TDX-UTIL(8)

NAME
tdx-util - Tradindexed overview manipulation utility

SYNOPSIS
tdx-util [-AFgio] [-a article] [-n newsgroup] [-p path] [-R path]

DESCRIPTION
tdx-util is an administrative interface to the tradindexed overview method for INN. It only works on tradindexed overview databases, not on any other type of INN overview. It allows the administrator to dump various information about the internal state of the overview, audit it for errors, and rebuild portions of the overview database.

The tradindexed overview method should lock properly and therefore it should be safe to run this utility and perform any operation it performs, including full repairs or per-group overview rebuilds, while the server is running. However, note that some of the operations performed by this utility can take an extended period of time and will hold locks in the overview database during that period, which depending on what the server is doing may cause the server to stall until tdx-util completes its operation.

The dump operations are -g, which dumps the master index for the overview database, -i, which dumps the index for an individual group, and -o, which dumps the overview information for a particular group (including the additional metadata stored in the index). For -i and -o, the -n option must also be given to specify a newsgroup to operate on.

To audit the entire overview database for problems, use -A. Any problems found will be reported to standard error. There is not (yet) a corresponding option to correct the errors found.

To rebuild the database for a particular newsgroup, use -R. The -R option takes a path to a directory which contains all of the articles for that newsgroup, one per file. The names of the files must be the numbers of the articles in that group. (In other words, this directory must be a traditional spool directory for that group.) The -n option must also be given to specify the newsgroup for which the overview is being rebuilt.

For all operations performed by tdx-util, a different overview database than the one specified in inn.conf may be specified using the -p option.

OPTIONS

-A  Audit the entire overview database for problems. This runs the internal consistency checks built into the tradindexed overview implementation, checking such things as the validity and reachability of all group index entries, the format of the individual overview entries, the correspondance of index entries to overview data, and similar such things. No changes will be made to the database, but problems will be reported to standard error.

-a article
    The article number to act on. Only useful in combination with the -o option to dump overview information.

-F  Audit the entire overview database for problems, fixing them as they're detected where possible. This runs the internal consistency checks built into the tradindexed overview implementation, checking such things as the validity and reachability of all group index entries, the format of the individual overview entries, the correspondance of index entries to overview data, and similar such things. The strategy used when fixing problems is to throw away data that's unrecoverable, so be warned that using this option may result in inaccessible articles if their overview data has been corrupted.

    To see what would be changed by -F, run tdx-util with -A first.

-g  Dump the master index of the overview database. This contains similar information to the server active file, such as high and low water marks and moderation status, and is the information that nnrpd hands out to clients.

    The fields are, in order, the newsgroup name, the high water mark, the low water mark, the base article number (the point at which the group index begins), the count of articles in the group, the group status flag, the time (in seconds since epoch) when that newsgroup was deleted or 0 if it hasn't been, and the inode of the index file for that group.

-i  Dump the index of a particular group. The fields are, in order, the article number, the offset of the data for that article in the overview data file for that group, the length of the overview data, the time (in seconds since epoch) when the article arrived on the server, the time (in seconds since epoch) when the article should expire based on its Expires header (or 0 if there is no Expires header), and the storage API token of the article.

    If this option is given, the -n option must also be given to specify the newsgroup on which to act.

-n newsgroup
    Specify the newsgroup on which to act, required for the -i, -o, and -R options.

-o  Dump the overview information for a newsgroup, in the same format as it would be returned to clients but with one modification. Appended to the end of each entry will be four additional pieces of data: the article number according to the index file for that group, the storage API token for that article, the arrival date for that article on the server in RFC 822 date format, and the expiration date for that article (from the Expires header) in RFC 822 date format if there is any.

    If this option is given, the -n option must also be given to specify the newsgroup on which to act. By default, all of the overview information for that newsgroup is dumped, but the -a option may be given to restrict the dump to the information for a single article.

-p path
    Act on the overview database rooted in path, overriding the overview path specified in inn.conf.

-R path
    Rebuild the overview for a given group from the articles stored in path. The articles must be in the form of a traditional spool directory; in other words, each article must be in a separate file and the name of the file must match the article number of the article.

    If this option is given, the -n option must also be given to specify the newsgroup on which to act.

EXAMPLES
Dump the master index for the overview database in /news/overview, regardless of the overview path specified in inn.conf:

    tdx-util -g -p /news/overview

Dump the group index for example.test:

    tdx-util -i -n example.test

Dump the complete overview information for example.test:

    tdx-util -o -n example.test

Audit the entire overview database for any problems:

    tdx-util -A

Rebuild the overview information for example.test from a traditional spool directory:

    tdx-util -R /news/spool/articles/example/test -n example.test

The last command may be useful for recovering from a bad crash or corrupted overview information for a particular group, if you are also using the tradspool article storage method.

HISTORY
Written by Russ Allbery <rra@stanford.edu> for InterNetNews.

$Id: tdx-util.8,v 1.2 2002/08/31 00:53:48 rra Exp $

SEE ALSO
makehistory(8)